use crate::Error;
use serde::Deserialize;
use serde_json::json;

pub(crate) struct Fal {
    key: String,
}

impl Fal {
    pub fn new(key: String) -> Self {
        Self { key }
    }

    pub async fn request(&self, model: &str, prompt: &str) -> Result<FalResult, Error> {
        let url = format!("https://fal.run/fal-ai/{model}");
        let response = reqwest::Client::new()
            .post(&url)
            .header("Authorization", format!("Key {}", self.key))
            .json(&json!({
                "prompt": prompt,
                "image_size": "square_hd",
            }))
            .send()
            .await?
            .json::<FalResult>()
            .await?;

        Ok(response)
    }
}

#[derive(Deserialize, Debug)]
pub struct FalResult {
    pub images: Vec<FalImage>,
}

#[derive(Deserialize, Debug)]
pub struct FalImage {
    pub url: String,
}
